<?php
/*
Plugin Name: Gallery Widget
Website link: http://blog.splash.de/
Author URI: http://blog.splash.de/
Plugin URI: http://blog.splash.de/plugins/gallery-widget/
Description: Simple widget to show the latest images of the wordpress media gallery (Wordpress 2.5++)
Author: Oliver Schaal
Version: 0.5.9

    This is a WordPress plugin (http://wordpress.org) and widget
    (http://automattic.com/code/widgets/).
*/

function gw_get_image_link($id, $linktype)
{
    if ($linktype == 'direct') {
        return wp_get_attachment_url($id);
    } else {
        return get_attachment_link($id);
    }
}

function get_attached_images_by_categories($_max = 5, $order = 'latest', $categories = 1, $option = 'include', $linktype = 'old', $linkclass = '')
{
    global $wpdb; // wordpress database access

    if ($order == 'random') {
        $_orderby = 'ORDER BY RAND()';
    } else {
        $_orderby = 'ORDER BY wp_posts.post_date DESC';
    }
    if ($option == 'exclude') {
        $_query = "SELECT * FROM wp_posts WHERE wp_posts.post_type = 'attachment' AND wp_posts.post_parent NOT IN ( SELECT ID FROM wp_posts INNER JOIN wp_term_relationships ON ( wp_posts.ID = wp_term_relationships.object_id ) WHERE wp_posts.post_type = 'post' AND wp_posts.post_status = 'publish' AND term_taxonomy_id IN ( $categories ) GROUP BY wp_posts.ID ) $_orderby LIMIT 0 , $_max";
    } else {
        $_query = "SELECT * FROM wp_posts WHERE wp_posts.post_type = 'attachment' AND wp_posts.post_parent = ANY( SELECT ID FROM wp_posts INNER JOIN wp_term_relationships ON ( wp_posts.ID = wp_term_relationships.object_id ) WHERE wp_posts.post_type = 'post' AND wp_posts.post_status = 'publish' AND term_taxonomy_id IN ( $categories ) GROUP BY wp_posts.ID ) $_orderby LIMIT 0 , $_max";
    }

    $_result = $wpdb->get_results($_query);

    $_retval = "<ul class=\"wGallery\">";

    if (count($_result > 0)) {
        foreach($_result as $_post) {
            if (!empty($linkclass)) {
                $_addcss = " class=\"$linkclass\"";
            }
            $_retval .= "<li class=\"wGallery\"><a href=\"" . gw_get_image_link($_post->ID, $linktype) . "\"" . $_addcss . "><img src=\"" . wp_get_attachment_thumb_url($_post->ID) . "\" alt=\"" . $_post->post_title . "\" /></a></li>";
        }
    }

    $_retval .= '</ul>';

    return $_retval;
}

function get_attached_images($_max = 5, $order = 'latest', $linktype = 'old', $linkclass = '')
{
    $_retval = "<ul class=\"wGallery\">";

    if ($order == 'random') {
        $r = new WP_Query("showposts=$_max&what_to_show=posts&post_status=inherit&post_type=attachment&orderby=rand&post_mime_type=image/jpeg,image/gif,image/jpg,image/png");
    } else {
        $r = new WP_Query("showposts=$_max&what_to_show=posts&post_status=inherit&post_type=attachment&orderby=menu_order ASC, ID ASC&post_mime_type=image/jpeg,image/gif,image/jpg,image/png");
    }

    if ($r->have_posts()) {
        while ($r->have_posts()) : $r->the_post();

        if (!empty($linkclass)) {
            $_addcss = " class=\"$linkclass\"";
        }
        $_retval .= "<li class=\"wGallery\"><a href=\"" . gw_get_image_link(get_the_ID(), $linktype) . "\"" . $_addcss . "><img src=\"" . wp_get_attachment_thumb_url(get_the_ID()) . "\" alt=\"" . get_the_title() . "\" /></a></li>";

        endwhile;
    }

    $_retval .= '</ul>';

    return $_retval;
}

function widget_wGallery_init()
{
    if (!function_exists('register_sidebar_widget') || !function_exists('register_widget_control'))
        return;

    function widget_wGallery($args)
    {
        extract($args);

        $options = get_option('widget_wGallery');

        $title = empty($options['title']) ? 'Gallery Widget' : $options['title'];
        $max = empty($options['max']) ? 5 : $options['max'];
        $order = empty($options['order']) ? 'latest' : $options['order'];
        $category_option = empty($options['category_option']) ? 'all' : $options['category_option'];
        $categories = empty($options['categories']) ? '' : $options['categories'];
        $showon = empty($options['showon']) ? 'all' : $options['showon'];
        $linktype = empty($options['linktype']) ? 'old' : $options['linktype'];
        $linkclass = empty($options['linkclass']) ? '' : $options['linkclass'];

        if ((is_home() && $showon == 'home') || $showon == 'all') {
            echo $before_widget;
            echo $before_title . $title . $after_title;
            if ($category_option == "include" || $category_option == "exclude") {
                echo get_attached_images_by_categories($max, $order, $categories, $category_option, $linktype, $linkclass);
            } else {
                echo get_attached_images($max, $order, $linktype, $linkclass);
            }
            echo $after_widget;
        }
    }

    function widget_wGallery_control()
    {
        $options = get_option('widget_wGallery');

        if ($_POST['wGallery-submit']) {
            $newoptions['title'] = strip_tags(stripslashes($_POST['wGallery-title']));
            $newoptions['order'] = strip_tags(stripslashes($_POST['wGallery-order']));
            $newoptions['max'] = strip_tags(stripslashes($_POST['wGallery-max']));
            $newoptions['category_option'] = strip_tags(stripslashes($_POST['wGallery-category_option']));
            $newoptions['categories'] = strip_tags(stripslashes($_POST['wGallery-categories']));
            $newoptions['showon'] = strip_tags(stripslashes($_POST['wGallery-showon']));
            $newoptions['linktype'] = strip_tags(stripslashes($_POST['wGallery-linktype']));
            $newoptions['linkclass'] = strip_tags(stripslashes($_POST['wGallery-linkclass']));
        }

        $options['title'] = (!empty($newoptions['title'])) ? $newoptions['title'] : $options['title'];
        $options['order'] = (!empty($newoptions['order'])) ? $newoptions['order'] : $options['order'];
        $options['max'] = (!empty($newoptions['max'])) ? $newoptions['max'] : $options['max'];
        $options['category_option'] = (!empty($newoptions['category_option'])) ? $newoptions['category_option'] : $options['category_option'];
        $options['categories'] = (!empty($newoptions['categories'])) ? $newoptions['categories'] : $options['categories'];
        $options['showon'] = (!empty($newoptions['showon'])) ? $newoptions['showon'] : $options['showon'];
        $options['linktype'] = (!empty($newoptions['linktype'])) ? $newoptions['linktype'] : $options['linktype'];
        $options['linkclass'] = $newoptions['linkclass'];
        update_option('widget_wGallery', $options);

        $title = htmlspecialchars($options['title'], ENT_QUOTES);
        $max = htmlspecialchars($options['max'], ENT_QUOTES);
        $order = htmlspecialchars($options['order'], ENT_QUOTES);
        $category_option = htmlspecialchars($options['category_option'], ENT_QUOTES);
        $categories = htmlspecialchars($options['categories'], ENT_QUOTES);
        $showon = htmlspecialchars($options['showon'], ENT_QUOTES);
        $linktype = htmlspecialchars($options['linktype'], ENT_QUOTES);
        $linkclass = htmlspecialchars($options['linkclass'], ENT_QUOTES);

        $ordervalue = array("latest", "random");
        $category_option_value = array('all', 'include', 'exclude');
        $showon_options = array('all', 'home');
        $linktype_options = array('old', 'direct');

        ?>
        <div>
        <label for="wGallery-title" style="line-height:35px;display:block;">widget title: <input type="text" id="wGallery-title" name="wGallery-title" value="<?php echo $title;

        ?>" /></label>
        <label for="wGallery-max" style="line-height:35px;display:block;">max images: <input type="text" id="wGallery-max" name="wGallery-max" value="<?php echo $max;

        ?>" /></label>

        <label for="wGallery-order" style="line-height:35px;display:block;">order:
		        <select name="wGallery-order" id="wGallery-order">
                <?php foreach ($ordervalue as $option) {

            ?>
                <option<?php if ($order == $option) {
                echo ' selected="selected"';
            }

            ?>><?php echo $option;

            ?></option>
                <?php }

        ?>
            </select>
		</label>

		<label for="wGallery-linktype" style="line-height:35px;display:block;">Linktype:
			<select name="wGallery-linktype" id="wGallery-linktype">
            <?php foreach ($linktype_options as $option) {

            ?>
                <option<?php if ($linktype == $option) {
                echo ' selected="selected"';
            }

            ?>><?php echo $option;

            ?></option>
                <?php }

        ?>
            </select>
		</label>
		<label for="wGallery-linkclass" style="line-height:35px;display:block;">CSS-Class to add to the link: <input type="text" id="wGallery-linkclass" name="wGallery-linkclass" value="<?php echo $linkclass;

        ?>" /></label>

		<label for="wGallery-showon" style="line-height:35px;display:block;">Where to show:
			<select name="wGallery-showon" id="wGallery-showon">
            <?php foreach ($showon_options as $option) {

            ?>
                <option<?php if ($showon == $option) {
                echo ' selected="selected"';
            }

            ?>><?php echo $option;

            ?></option>
                <?php }

        ?>
            </select>
		</label>

        <label for="wGallery-category_option" style="line-height:35px;display:block;">category-option:
			<select name="wGallery-category_option" id="wGallery-category_option">
            <?php foreach ($category_option_value as $option) {

            ?>
                <option<?php if ($category_option == $option) {
                echo ' selected="selected"';
            }

            ?>><?php echo $option;

            ?></option>
                <?php }

        ?>
            </select>
		</label>

        <label for="wGallery-categories" style="line-height:35px;display:block;">categories (comma separated): <input type="text" id="wGallery-categories" name="wGallery-categories" value="<?php echo $categories;

        ?>" /></label>

        <input type="hidden" name="wGallery-submit" id="wGallery-submit" value="1" />
        </div>
    <?php

    }
    // Need to register the widget and the control form.
    register_sidebar_widget(__('Gallery Widget', 'wGallery'), 'widget_wGallery');
    register_widget_control(__('Gallery Widget', 'wGallery'), 'widget_wGallery_control', 300, 200);
}

function widget_wGallery_deactivate()
{
    delete_option('widget_wGallery');
}

register_deactivation_hook(__FILE__, 'widget_wGallery_deactivate');
add_action('plugins_loaded', 'widget_wGallery_init');

?>